import * as shiki from 'shiki';
import { IThemeRegistration } from 'shiki';
import MarkdownIt from 'markdown-it';
import { Options, IExtraProcessor, DarkModeThemes, ElementProcessorType } from './types.js';
export { ExtraPosition, IElementIntel, IProcessorOutput } from './types.js';

declare function resolveOptions(options: Options): {
    themes: IThemeRegistration[];
    darkModeThemes: {
        dark: string;
        light: string;
    } | undefined;
    extra: IExtraProcessor[];
    theme?: IThemeRegistration | DarkModeThemes | undefined;
    langs?: shiki.ILanguageRegistration[] | undefined;
    timeout?: number | undefined;
    highlighter?: shiki.Highlighter | undefined;
    highlightLines?: boolean | undefined;
};
declare const h: ElementProcessorType;
declare const MarkdownItShiki: MarkdownIt.PluginWithOptions<Options>;

export { DarkModeThemes, ElementProcessorType, IExtraProcessor, Options, MarkdownItShiki as default, h, resolveOptions };
