"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ExtraPosition: () => ExtraPosition,
  default: () => src_default,
  h: () => h,
  resolveOptions: () => resolveOptions
});
module.exports = __toCommonJS(src_exports);

// node_modules/.pnpm/tsup@6.6.3_typescript@4.9.5/node_modules/tsup/assets/cjs_shims.js
var getImportMetaUrl = () => typeof document === "undefined" ? new URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;
var importMetaUrl = /* @__PURE__ */ getImportMetaUrl();

// src/index.ts
var import_module = require("module");
var import_synckit = require("synckit");

// src/types.ts
var ExtraPosition = /* @__PURE__ */ ((ExtraPosition2) => {
  ExtraPosition2[ExtraPosition2["before"] = 0] = "before";
  ExtraPosition2[ExtraPosition2["f_top_right"] = 1] = "f_top_right";
  ExtraPosition2[ExtraPosition2["f_top_left"] = 2] = "f_top_left";
  ExtraPosition2[ExtraPosition2["f_bottom_right"] = 3] = "f_bottom_right";
  ExtraPosition2[ExtraPosition2["f_bottom_left"] = 4] = "f_bottom_left";
  ExtraPosition2[ExtraPosition2["after"] = 5] = "after";
  return ExtraPosition2;
})(ExtraPosition || {});
var PREPENDING_POSITIONS = [0 /* before */, 1 /* f_top_right */, 2 /* f_top_left */];
var APPENDING_POSITIONS = [3 /* f_bottom_right */, 4 /* f_bottom_left */, 5 /* after */];
var FLOATING_POSITIONS = [1 /* f_top_right */, 3 /* f_bottom_right */, 2 /* f_top_left */, 4 /* f_bottom_left */];
var FLOATING_TOP = [1 /* f_top_right */, 2 /* f_top_left */];
var FLOATING_BOTTOM = [3 /* f_bottom_right */, 4 /* f_bottom_left */];
var FLOATING_RIGHT = [1 /* f_top_right */, 3 /* f_bottom_right */];
var FLOATING_LEFT = [2 /* f_top_left */, 4 /* f_bottom_left */];

// src/index.ts
function getThemeName(theme) {
  if (typeof theme === "string")
    return theme;
  return theme.name;
}
var HIGHLIGHT_RE = /{([\d,-]+)}/;
var BACKGROUND_STYLE_RE = /^<pre[^>]*style="([^"]*)"[^>]*>/;
var DARK_CLASS = "shiki-dark";
var LIGHT_CLASS = "shiki-light";
var FLOAT_CLASS = "shiki-float";
var FLOAT_POS_CLASS_MAPPING = {
  "shiki-float-top": FLOATING_TOP,
  "shiki-float-bottom": FLOATING_BOTTOM,
  "shiki-float-right": FLOATING_RIGHT,
  "shiki-float-left": FLOATING_LEFT
};
var FLOAT_POS_CLASS_ITER = Object.entries(FLOAT_POS_CLASS_MAPPING);
function resolveOptions(options) {
  const themes = [];
  let darkModeThemes;
  if (!options.theme) {
    themes.push("nord");
  } else if (typeof options.theme === "string") {
    themes.push(options.theme);
  } else {
    if ("dark" in options.theme || "light" in options.theme) {
      darkModeThemes = options.theme;
      themes.push(darkModeThemes.dark);
      themes.push(darkModeThemes.light);
    } else {
      themes.push(options.theme);
    }
  }
  return {
    ...options,
    themes,
    darkModeThemes: darkModeThemes ? {
      dark: getThemeName(darkModeThemes.dark),
      light: getThemeName(darkModeThemes.light)
    } : void 0,
    extra: options.extra || []
  };
}
var attrsToLines = (attrs) => {
  const result = [];
  if (!attrs.trim())
    return [];
  attrs.split(",").map((v) => v.split("-").map((v2) => parseInt(v2, 10))).forEach(([start, end]) => {
    if (start && end) {
      result.push(
        ...Array.from({ length: end - start + 1 }, (_, i) => start + i)
      );
    } else {
      result.push(start);
    }
  });
  return result.map((v) => ({
    line: v,
    classes: ["highlighted"]
  }));
};
var processExtra = (extra, attrs, lang, code) => {
  const result = [];
  if (extra === void 0)
    return result;
  extra.forEach((processor) => {
    const matched = processor.attrRe ? processor.attrRe.exec(attrs) : null;
    result.push({
      light: processor.light(matched, lang, code),
      dark: processor.dark === null ? null : (processor.dark || processor.light)(matched, lang, code),
      position: processor.position
    });
  });
  return result;
};
var getStyleContent = (tag, regex) => {
  const match = regex.exec(tag);
  let style_content = "";
  if (match)
    style_content = match[1];
  return style_content;
};
var appendStyle = (intel, style) => {
  if (!intel)
    return;
  if (!style.endsWith(";"))
    style += ";";
  if (intel.attrs.style)
    intel.attrs.style += `;${style}`;
  else
    intel.attrs.style = style;
};
var appendClass = (intel, className) => {
  if (!intel)
    return;
  if (intel.attrs.class)
    intel.attrs.class += ` ${className}`;
  else
    intel.attrs.class = className;
};
var h = (intel) => {
  if (!intel)
    return "";
  const headPartal = `<${intel.tag}${Object.entries(intel.attrs).reduce((prev, now) => {
    return `${prev} ${now[0]}="${now[1]}"`;
  }, "")}`;
  if (intel.content) {
    if (typeof intel.content === "string")
      return `${headPartal}>${intel.content}</${intel.tag}>`;
    else if (Array.isArray(intel.content))
      return `${headPartal}>${intel.content.reduce((prev, now) => prev + h(now), "")}</${intel.tag}>`;
    else
      return `${headPartal}>${h(intel.content)}</${intel.tag}>`;
  } else {
    return `${headPartal} />`;
  }
};
var wrapFinalContainer = (light, dark = void 0, processedExtra = void 0) => {
  const extraContentsOnPosition = Object.keys(ExtraPosition).map(() => "");
  dark = dark || "";
  processedExtra = processedExtra || [];
  const light_style_content = getStyleContent(light, BACKGROUND_STYLE_RE);
  const dark_style_content = getStyleContent(dark, BACKGROUND_STYLE_RE);
  processedExtra.forEach((extra) => {
    if (extra.dark !== null) {
      appendClass(extra.light, LIGHT_CLASS);
      appendStyle(extra.light, light_style_content);
      appendClass(extra.dark, DARK_CLASS);
      appendStyle(extra.dark, dark_style_content);
    } else {
      extra.dark = void 0;
    }
    if (FLOATING_POSITIONS.includes(extra.position)) {
      appendClass(extra.light, FLOAT_CLASS);
      appendClass(extra.dark, FLOAT_CLASS);
    }
    for (const [posClass, posCheckList] of FLOAT_POS_CLASS_ITER) {
      if (posCheckList.includes(extra.position)) {
        appendClass(extra.light, posClass);
        appendClass(extra.dark, posClass);
      }
    }
    const lightExtra = h(extra.light);
    const darkExtra = h(extra.dark);
    extraContentsOnPosition[extra.position] += lightExtra;
    extraContentsOnPosition[extra.position] += darkExtra;
  });
  const before = PREPENDING_POSITIONS.map((i) => extraContentsOnPosition[i]).reduce((prev, exc) => prev + exc, "");
  const after = APPENDING_POSITIONS.map((i) => extraContentsOnPosition[i]).reduce((prev, exc) => prev + exc, "");
  return `<div class="shiki-container" style="position: relative;">${before}${light}${dark}${after}</div>`;
};
var MarkdownItShiki = (markdownit, options = {}) => {
  const _highlighter = options.highlighter;
  const {
    langs,
    themes,
    darkModeThemes,
    highlightLines,
    extra
  } = resolveOptions(options);
  let syncRun;
  if (!_highlighter) {
    const require2 = (0, import_module.createRequire)(importMetaUrl);
    syncRun = (0, import_synckit.createSyncFn)(require2.resolve("./worker"));
    syncRun("getHighlighter", { langs, themes });
  }
  const highlightCode = (code, lang, theme, lineOptions) => {
    if (_highlighter)
      return _highlighter.codeToHtml(code, { lang: lang || "text", theme, lineOptions });
    return syncRun("codeToHtml", {
      code,
      theme,
      lang: lang || "text",
      lineOptions
    });
  };
  markdownit.options.highlight = (code, lang, attrs) => {
    let lineOptions;
    if (highlightLines) {
      const match = HIGHLIGHT_RE.exec(attrs);
      if (match)
        lineOptions = attrsToLines(match[1]);
    }
    const processedExtra = processExtra(extra, attrs, lang, code);
    if (darkModeThemes) {
      const dark = highlightCode(code, lang, darkModeThemes.dark, lineOptions).replace('<pre class="shiki', `<pre class="shiki ${DARK_CLASS}`);
      const light = highlightCode(code, lang || "text", darkModeThemes.light, lineOptions).replace('<pre class="shiki', `<pre class="shiki ${LIGHT_CLASS}`);
      return wrapFinalContainer(light, dark, processedExtra);
    } else {
      return wrapFinalContainer(
        highlightCode(
          code,
          lang || "text",
          void 0,
          lineOptions
        ),
        void 0,
        processedExtra
      );
    }
  };
};
var src_default = MarkdownItShiki;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ExtraPosition,
  h,
  resolveOptions
});
